=== modified file 'bin/lp-review-list'
--- bin/lp-review-list	2010-02-01 05:30:54 +0000
+++ bin/lp-review-list	2010-02-20 02:27:13 +0000
@@ -17,25 +17,21 @@
 # with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 from __future__ import with_statement
+from ConfigParser import ConfigParser
+import os
+import re
+import subprocess
+import sys
+from threading import Thread
 
 import pygtk
 pygtk.require('2.0')
 import gobject
 import gtk
 import pango
-
-from ConfigParser import ConfigParser
-import os
-import re
-import subprocess
-import sys
-
 from xdg.BaseDirectory import xdg_cache_home, xdg_config_home
 
-from threading import Thread
-
-from launchpadlib.launchpad import Launchpad, EDGE_SERVICE_ROOT
-from launchpadlib.credentials import Credentials
+from lptools import config
 
 VOTES = { "Approve" : "#00ff00",
           "Needs Fixing" : "#993300",
@@ -65,6 +61,7 @@
             else:
                   self.projects = []
 
+            # XXX: Not currently honoured - not sure if it ever worked.
             if self.config.has_option("lptools", "server"):
                   self.api_server = self.config.get("lptools", "server")
             else:
@@ -167,7 +164,7 @@
             self.set_title("Pending Reviews")
             self.set_default_size(320, 400)
             self.connect("destroy", lambda w: gtk.main_quit())
-            self.connect("delete_event", lambda w: gtk.main_quit())
+            self.connect("delete_event", lambda w,x: gtk.main_quit())
 
             vbox = gtk.VBox()
             self.add(vbox)
@@ -203,9 +200,8 @@
             col = gtk.TreeViewColumn("Branch", cell, markup=0)
             view.append_column(col)
 
-            self.cachedir = os.path.join(xdg_cache_home, "review-list")
-            if not os.path.isdir(self.cachedir):
-                  os.makedirs(self.cachedir)
+            self.cachedir = os.path.join(config.xdg_cache_home, "review-list")
+            config.ensure_dir(self.cachedir)
 
             self.launchpad = None
             self.me = None
@@ -220,21 +216,7 @@
             Thread(target=self.__lp_login).start()
 
       def __lp_login(self):
-            credsfile = os.path.join(self.cachedir, "credentials")
-
-            if os.path.exists(credsfile):
-                  creds = Credentials()
-
-                  with file(credsfile) as f:
-                        creds.load(f)
-                  self.launchpad = Launchpad(creds, EDGE_SERVICE_ROOT)
-            else:
-                  self.launchpad = Launchpad.get_token_and_login(
-                        'review-list',
-                        EDGE_SERVICE_ROOT,
-                        self.cachedir)
-                  with file(credsfile, "w") as f:
-                        self.launchpad.credentials.save(f)
+            self.launchpad = config.get_launchpad(self.cachedir)
 
             self.me = self.launchpad.me
 

=== modified file 'bin/lp-review-notifier'
--- bin/lp-review-notifier	2010-02-01 05:30:54 +0000
+++ bin/lp-review-notifier	2010-02-20 02:27:13 +0000
@@ -17,21 +17,18 @@
 # with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 from __future__ import with_statement
+import os
+import sys
 
-import pygtk
-pygtk.require('2.0')
 import gobject
 import gtk
-
+import pygtk
 import pynotify
-
-import os
-import sys
-
 from xdg.BaseDirectory import xdg_cache_home
 
-from launchpadlib.launchpad import Launchpad, EDGE_SERVICE_ROOT
-from launchpadlib.credentials import Credentials
+from lptools import config
+
+pygtk.require('2.0')
 
 ICON_NAME = "bzr-icon-64"
 
@@ -40,24 +37,10 @@
     def __init__(self):
         self.id = 0
         self.cached_candidates = {}
-
+        
         self.cachedir = os.path.join(xdg_cache_home, "review-notifier")
-        credsfile = os.path.join(self.cachedir, "credentials")
-
-        if not os.path.isdir(self.cachedir):
-            os.makedirs(self.cachedir)
-
-        if os.path.exists(credsfile):
-            creds = Credentials()
-            with file(credsfile) as f:
-                creds.load(f)
-            self.launchpad = Launchpad(creds, EDGE_SERVICE_ROOT)
-        else:
-            self.launchpad = Launchpad.get_token_and_login('review-notifier',
-                                                           EDGE_SERVICE_ROOT,
-                                                           self.cachedir)
-            with file(credsfile, "w") as f:
-                self.launchpad.credentials.save(f)
+        config.ensure_dir(self.cachedir)
+        self.launchpad = config.get_launchpad(self.cachedir)
 
         self.me = self.launchpad.me
 
@@ -65,6 +48,7 @@
 
         self.projects = []
 
+        # TODO: get the config from lptools.conf
         for arg in sys.argv:
             if not arg.endswith("review-notifier"):
                 self.projects.append(arg)

=== added directory 'lptools'
=== added file 'lptools/__init__.py'
--- lptools/__init__.py	1970-01-01 00:00:00 +0000
+++ lptools/__init__.py	2010-02-20 02:27:13 +0000
@@ -0,0 +1,20 @@
+# Author: Robert Collins <robert.collins@canonical.com>
+#
+# Copyright 2010 Canonical Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranties of
+# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
+# PURPOSE.  See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+"""LP-tools is largely command line tools. The package contains various helpers.
+
+See lptools.config for configuration support logic.
+"""

=== added file 'lptools/config.py'
--- lptools/config.py	1970-01-01 00:00:00 +0000
+++ lptools/config.py	2010-02-20 02:27:13 +0000
@@ -0,0 +1,76 @@
+# Author: Robert Collins <robert.collins@canonical.com>
+#
+# Copyright 2010 Canonical Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranties of
+# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
+# PURPOSE.  See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+from __future__ import with_statement
+
+"""Configuration glue for lptools."""
+
+__all__ = [
+    "ensure_dir",
+    "get_launchpad",
+    "lptools_cachedir",
+    "lptools_credentials_path",
+    ]
+
+import os.path
+
+from launchpadlib.credentials import Credentials
+from launchpadlib.launchpad import Launchpad, EDGE_SERVICE_ROOT
+from xdg.BaseDirectory import xdg_cache_home
+
+
+def ensure_dir(dir):
+    """Ensure that dir exists."""
+    if not os.path.isdir(dir):
+        os.makedirs(dir)
+
+
+def get_launchpad(cachedir):
+    """Get a login to launchpad for lptools caching in cachedir.
+    
+    Note that caching is not multiple-process safe in launchpadlib.
+    """
+    credspath = lptools_credentials_path()
+    if os.path.exists(credspath):
+        creds = Credentials()
+        with file(credspath) as f:
+            creds.load(f)
+        return Launchpad(creds, EDGE_SERVICE_ROOT, cachedir)
+    else:
+        result = Launchpad.get_token_and_login('lptools',
+            EDGE_SERVICE_ROOT, cachedir)
+        with file(credspath, "w") as f:
+            result.credentials.save(f)
+        return result
+
+
+def lptools_cachedir():
+    """Return the cachedir for common lptools things.
+    
+    This is xdg_cache_home/lptools.
+    """
+    return os.path.join(xdg_cache_home, "lptools")
+
+
+def lptools_credentials_path():
+    """Return the path to the lptools credentials file.
+    
+    This also ensures the path is usable by checking it's containing directory
+    exists.
+    """
+    cachedir = lptools_cachedir()
+    ensure_dir(cachedir)
+    return os.path.join(lptools_cachedir(), 'credentials')

=== modified file 'setup.py'
--- setup.py	2010-02-20 00:19:41 +0000
+++ setup.py	2010-02-20 02:27:13 +0000
@@ -16,6 +16,7 @@
     description='A collection of tools for developers who use launchpad',
     long_description=description,
     py_modules=[],
+    packages=['lptools'],
     scripts=glob('bin/*'),
     classifiers = [
         'Development Status :: 4 - Beta',

